/* ANTINAT
 * =======
 * This software is Copyright (c) 2003 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../../../config.h"
#include <DSNetwork.h>
#include <DSList.h>
#include <DSComponent.h>
#include "../../Connection.h"
#include "../../moddecl.h"

DSList *unpwsources;

BOOL cpp_auth(Connection * conn)
{
	DSListElement * le;
	proc_unpwsource source;
	unsigned char version;
	unsigned char length;
	char * username;
	char * passwd;
	char rep[3];
	BOOL authed;

	authed=FALSE;
	username=passwd=NULL;
	if (!conn->getChar(&version)) return FALSE;
	if (version!=1) return FALSE;
	if (!conn->getChar(&length)) return FALSE;

	/* getSlab null terminates */
	username=(char *)malloc(length+1);
	if (!conn->getSlab(username,length)) goto barfed;
	if (!conn->getChar(&length)) goto barfed;
	passwd=(char *)malloc(length+1);
	if (!conn->getSlab(passwd,length)) goto barfed;

	/* Basically, we scan through each authentication source.  If any
	 * know anything about this user, then they're authenticated. */
	for (le=unpwsources->getHead();le!=NULL;le=le->getNext()) {
		source=(proc_unpwsource)le->getDataPtr();
		if (source(conn, username, passwd)) {
			authed=TRUE;
			conn->setUser(username);
			break;
		}

	}

barfed:
	rep[0]='\0';
	if (authed) {
#ifdef WITH_DEBUG
		printf("User %s authenticated\n", username);
#endif
		rep[1]='\0';
	} else {
#ifdef WITH_DEBUG
		printf("User %s NOT authenticated\n", username);
#endif
		rep[1]=0x01;
	}
	conn->sendData(rep,2);
	if (username) free(username);
	if (passwd) free(passwd);
	return authed;
}

extern "C" {
int authenticator_type()
{
	int i;
	unpwsources=new DSList();
	DSComponent unpwsrc(unpwsources);
	i=unpwsrc.loadcomponents(componentdir "/version5/authenticators/unpwsources", "init_source", "auth");
#ifdef WITH_DEBUG
	printf("Loaded %i username/password source components\n",i);
#endif
	return 2;
}

BOOL auth(void * conn)
{
	return cpp_auth((Connection *)conn);
}
}
